# struct XML::Reader

- XML::Reader
- Struct
- Value
- Object

##
Defined in:

##
Constructors

- .new(str : String, options : XML::ParserOptions = XML::ParserOptions.default)

  Creates a new reader from a string.

- .new(io : IO, options : XML::ParserOptions = XML::ParserOptions.default)

  Creates a new reader from an IO.

##
Instance Method Summary

- #[](attribute : String) : String

  Gets the attribute content for the attribute given by name.

- #[]?(attribute : String) : String?

  Gets the attribute content for the attribute given by name.

- #attributes_count

  Returns attribute count of the node.

- #depth

  Returns the current nesting depth of the reader.

- #empty_element?

  Checks if the node is an empty element.

- #expand : XML::Node

  Expands the node to a `XML::Node` that can be searched with XPath etc.

- #expand? : XML::Node?

  Expands the node to a `XML::Node` that can be searched with XPath etc.

- #has_attributes?

  Checks if the node has any attributes.

- #move_to_attribute(name : String)

  Moves to the `XML::Reader::Type::ATTRIBUTE` with the specified name.

- #move_to_element

  Moves from the `XML::Reader::Type::ATTRIBUTE` to its containing `XML::Reader::Type::ELEMENT`.

- #move_to_first_attribute

  Moves to the first `XML::Reader::Type::ATTRIBUTE` of the node.

- #move_to_next_attribute

  Moves to the next `XML::Reader::Type::ATTRIBUTE` of the node.

- #name

  Returns the name of the node.

- #next

  Moves the reader to the next node while skipping subtrees.

- #next_sibling

  Moves the reader to the next sibling node while skipping subtrees.

- #node_type : XML::Reader::Type

  Returns the `XML::Reader::Type` of the node.

- #read

  Moves the reader to the next node.

- #read_inner_xml

  Returns the node's XML content including subtrees.

- #read_outer_xml

  Returns the XML for the node and its content including subtrees.

- #to_unsafe : LibXML::XMLTextReader

  Returns a reference to the underlying `LibXML::XMLTextReader`.

- #value

  Returns the text content of the node.

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(str : String, options : XML::ParserOptions = XML::ParserOptions.default) #

Creates a new reader from a string.

See `XML::ParserOptions.default` for default options.

def self.new(io : IO, options : XML::ParserOptions = XML::ParserOptions.default) #

Creates a new reader from an IO.

See `XML::ParserOptions.default` for default options.

##
Instance Method Detail

def [](attribute : String) : String #

Gets the attribute content for the attribute given by name. Raises `KeyError` if attribute is not found.

def []?(attribute : String) : String? #

Gets the attribute content for the attribute given by name. Returns `nil` if attribute is not found.

def attributes_count #

Returns attribute count of the node.

def depth #

Returns the current nesting depth of the reader.

def empty_element? #

Checks if the node is an empty element.

def expand : XML::Node #

Expands the node to a `XML::Node` that can be searched with XPath etc. The returned `XML::Node` is only valid until the next call to `#read`.

Raises a `XML::Error` if the node could not be expanded.

def expand? : XML::Node? #

Expands the node to a `XML::Node` that can be searched with XPath etc. The returned `XML::Node` is only valid until the next call to `#read`.

Returns `nil` if the node could not be expanded.

def has_attributes? #

Checks if the node has any attributes.

def move_to_attribute(name : String) #

Moves to the `XML::Reader::Type::ATTRIBUTE` with the specified name.

def move_to_element #

Moves from the `XML::Reader::Type::ATTRIBUTE` to its containing `XML::Reader::Type::ELEMENT`.

def move_to_first_attribute #

Moves to the first `XML::Reader::Type::ATTRIBUTE` of the node.

def move_to_next_attribute #

Moves to the next `XML::Reader::Type::ATTRIBUTE` of the node.

def name #

Returns the name of the node.

def next #

Moves the reader to the next node while skipping subtrees.

def next_sibling #

Moves the reader to the next sibling node while skipping subtrees.

def node_type : XML::Reader::Type #

Returns the `XML::Reader::Type` of the node.

def read #

Moves the reader to the next node.

def read_inner_xml #

Returns the node's XML content including subtrees.

def read_outer_xml #

Returns the XML for the node and its content including subtrees.

def to_unsafe : LibXML::XMLTextReader #

Returns a reference to the underlying `LibXML::XMLTextReader`.

def value #

Returns the text content of the node.